% -------------------------------------------------------------------------
% ---------------------   Universidad de Guanajuato   ---------------------
% -----------------------------    F.I.M.E.E.  ----------------------------
% ----------------------------- Lab. Calculo I  ---------------------------
% ------------------------------  Practica 4    ---------------------------
% ----------------  Prof. Ing. Daniel Arturo Razo Montes ------------------
% -------------------------------------------------------------------------

clc         % Borra lo escrito y desplegado en la ventana de comandos
clear all   % Inicializa el espacio de trabajo en 0's; borra las variables
close all   % Cierra todas las ventanas abiertas (...de figuras)
            % previas
syms x t w  % declaracion de un objeto simbolico
v = [];     % variable auxiliar
% ------------------------------- Ejemplo 1 -------------------------------
y_11 = x^4+4*x^3-2*x^2-12*x; % funcion dada (simbolica)
disp('--------------------------- Ejemplo 1 ---------------------------');
disp('y_1(x) = ')
pretty(y_11)
disp('derivada de la funcion y_1(x) = ')
der_1 = diff(y_11,x);        % derivada de una funcion
pretty(der_1)
disp('valores criticos de y_1(x) = ')
vc_1 = solve(der_1);         % valores criticos, solve, hace igual a 0 la
                             % expresion en su argumento
pretty(vc_1')
v = vc_1;
y_12 = v.^4+4*v.^3-2*v.^2-12*v; % funcion dada, igual que la simbolica,
                                % se utilizara como auxiliar para evaluar
                                % la funcion en sus valores criticos
disp('-----------------------------------------------------------------');
figure('Name','Ejemplo 1')
subplot(1,2,1)              % varios ejes coordenados en una misma figura
ezplot(y_11)
hold on
plot(double(vc_1(1)),double(y_12(1)),'rx')  % marcas en la grafica para
plot(double(vc_1(2)),double(y_12(2)),'rs')  % los valores criticos
plot(double(vc_1(3)),double(y_12(3)),'rd')
title('y_{1} = x^4+4*x^3-2*x^2-12*x')
grid
subplot(1,2,2)
ezplot(der_1)
title('y\prime_{1}(x)')
grid
% -------------------------------------------------------------------------

% ------------------------------- Ejemplo 2 -------------------------------
y_21 = (w^3-3*w^2+4)^(1/3);  % funcion dada (simbolica)
disp('--------------------------- Ejemplo 2 ---------------------------');
disp('y_2(w) = ')
pretty(y_21)
disp('derivada de la funcion y_2(w) = ')
der_2 = diff(y_21,w);        % derivada de una funcion
pretty(der_2)
[num_1 ans] = numden (der_2);% regresa el numerador de una expresion
[ans den_1] = numden (der_2);% regresa el denominador de una expresion
disp('valores criticos de y_2(w) = ')
vc_21 = solve(num_1,'w');    % valores criticos, solve, hace igual a 0 la
                             % expresion en su argumento
vc_22 = solve(den_1,'w');    % valores criticos, solve, hace igual a 0 la
                             % expresion en su argumento
pretty(vc_21')
pretty(vc_22')
v = [vc_21' vc_22'];
y_22 = (v.^3-3*v.^2+4).^(1/3);  % funcion dada, igual que la simbolica,
                                % se utilizara como auxiliar para evaluar
                                % la funcion en sus valores criticos
disp('-----------------------------------------------------------------');
figure('Name','Ejemplo 2')
subplot(1,2,1)              % varios ejes coordenados en una misma figura
ezplot(y_21)
hold on
plot(double(vc_21(1)),double(y_22(1)),'rd')  % marcas en la grafica para
plot(double(vc_21(2)),double(y_22(2)),'rs')  % los valores criticos
plot(double(vc_22(1)),double(y_22(3)),'rd')
title('y_{2} = (w^3-3*w^2+4)^(1/3)')
grid
subplot(1,2,2)
ezplot(der_2)
title('y\prime_{2}(w)')
grid
% -------------------------------------------------------------------------

% ------------------------------- Ejemplo 3 -------------------------------
y_31 = (x^2+2*x+5)/(x-1);    % funcion dada (simbolica)
disp('--------------------------- Ejemplo 3 ---------------------------');
disp('y_3(x) = ')
pretty(y_31)
disp('derivada de la funcion y_3(x) = ')
der_3 = diff(y_31,x);        % derivada de una funcion
der_3 = simplify(der_3);
pretty(der_3)
disp('valores criticos de y_3(x) = ')
vc_3 = solve(der_3);         % valores criticos, solve, hace igual a 0 la
                             % expresion en su argumento
pretty(vc_3')
v = vc_3;
% v = vpa(v);
y_32 = (v.^2+2*v+5)./(v-1); % funcion dada, igual que la simbolica,
                            % se utilizara como auxiliar para evaluar
                            % la funcion en sus valores criticos
disp('-----------------------------------------------------------------');
figure('Name','Ejemplo 3')
subplot(1,2,1)              % varios ejes coordenados en una misma figura
ezplot(y_31)
hold on
plot(double(vc_3(1)),double(y_32(1)),'rd')  % marcas en la grafica para
plot(double(vc_3(2)),double(y_32(2)),'rs')  % los valores criticos
title('y_{3} = (x^2+2*x+5)/(x-1)')
grid
subplot(1,2,2)
ezplot(der_3)
title('y\prime_{3}(x)')
grid
% -------------------------------------------------------------------------

% ------------------------------- Ejemplo 4 -------------------------------
y_41 = sin(2*x) + cos(2*x);  % funcion dada (simbolica)
disp('--------------------------- Ejemplo 4 ---------------------------');
disp('y_4(x) = ')
pretty(y_41)
disp('derivada de la funcion y_4(x) = ')
der_4 = diff(y_41,x);       % derivada de una funcion
der_4 = simplify(der_4);
pretty(der_4)
disp('valores criticos de y_4(x) = ')
vc_4 = solve(der_4');       % valores criticos, solve, hace igual a 0 la
                            % expresion en su argumento
pretty(vc_4')
v = vc_4;
% v = vpa(v);
y_42 = sin(2*v) + cos(2*v); % funcion dada, igual que la simbolica,
                            % se utilizara como auxiliar para evaluar
                            % la funcion en sus valores criticos
disp('-----------------------------------------------------------------');
figure('Name','Ejemplo 4')
subplot(1,2,1)              % varios ejes coordenados en una misma figura
ezplot(y_41)
hold on
for n = -10:2:10
    plot(double(vc_4(1))-pi*(n-1)/2,double(-y_42(1)),'rd')
    plot(double(vc_4(1))+pi*n/2,double(y_42(1)),'rs')
end
title('y_{4} = sin(2*x) + cos(2*x)')
grid
subplot(1,2,2)
ezplot(der_4)
title('y\prime_{4}(x)')
grid
% -------------------------------------------------------------------------

% ------------------------------- Ejemplo 5 -------------------------------
y_51 = abs(4-x^2);           % funcion dada (simbolica)
disp('--------------------------- Ejemplo 5 ---------------------------');
disp('y_5(x) = ')
pretty(y_51)
disp('derivada de la funcion y_5(x) = ')
der_5 = diff(y_51,x);        % derivada de una funcion
der_5 = simplify(der_5);
pretty(der_5)
disp('valores criticos de y_5(x) = ')
vc_51 = solve(der_5);        % valores criticos, solve, hace igual a 0 la
vc_52 = solve('4-x^2');      % expresion en su argumento
vc_5 = [vc_51' vc_52'];
pretty(vc_5)
v = vc_5;
% v = vpa(v);
y_52 = abs(4-v.^2);          % funcion dada, igual que la simbolica,
                             % se utilizara como auxiliar para evaluar
                             % la funcion en sus valores criticos
disp('-----------------------------------------------------------------');
figure('Name','Ejemplo 5')
subplot(1,2,1)              % varios ejes coordenados en una misma figura
ezplot(y_51)
hold on
plot(double(vc_5(1)),double(y_52(1)),'rs')  % marcas en la grafica para
plot(double(vc_5(2)),double(y_52(2)),'rs')  % los valores criticos
plot(double(vc_5(3)),double(y_52(2)),'rs')
title('y_{5} = abs(4-x^2)')
grid
subplot(1,2,2)
% ezplot(der_5)
ezplot('2*x*abs(-4+x^2)')
title('y\prime_{5}(x)')
grid
% -------------------------------------------------------------------------

